;Script file for Eudora version 4.2 or later
;Copyright 2000 Henter-Joyce, Inc.
; By DB
; Includes scripts and functions by KAG
; Build 4.0.010

Include "hjglobal.jsh" ; default HJ global variables
Include "hjconst.jsh" ; default HJ constants
include "HjHelp.jsh"; for the AppFileTopic function
Include "eudora.jsm" ; Eudora message file
include "eudora.jsh"


Globals
	int EudoraVersion,
Int EudoraFirstTime,
Int DownloadSpeak,
	int iGlobalPrevControl,
	int nSkipHeaders,
	int nSuppressEcho,
	int AddressBookFirstTime,
	int FilterFirstTime


Void Function AutoStartEvent ()
let nSuppressEcho = false
Pause()
If (DialogActive ()) then
	if GetWindowClass (GetFocus ())=="SysTreeView32"
	then ScheduleFunction ("CloseTree", 50)
	ElIf (GetWindowClass (GetFocus ()) == wcNoFocus) then
		ScheduleFunction ("FocusEudora", 20)
	endif
EndIf
If (EudoraFirstTime == 0) Then
	let EudoraVersion = GetEudoraVersion ()
	Let EudoraFirstTime =1
	Let DownloadSpeak =0
		SayMessage (OT_app_start, msg39_L, msg39_s) ; "For a list of Eudora hot key functions, press Insert+H."
 SayMessage(OT_APP_START, msgExtendedHelp_L, msgExtendedHelp_S )
EndIf
EndFunction

Int Function GetEudoraVersion ()
;Determines what version of Eudora is being used
var
	int nVersion
let nVersion = GetProgramVersion (GetAppFilePath ())
	return nVersion	
EndFunction

Function CloseTree (){ctrl+f4}
pause()
{ctrl+1}
EndFunction

Void Function FocusEudora ()
let nSuppressEcho = true
SaveCursor ()
InvisibleCursor ()
MoveToWindow (FindDescendantWindow (GetAppMainWindow (GetFocus ()), ID_Messages_List))
RoutePcToInvisible ()
let nSuppressEcho = false
EndFunction

Void Function CloseListMain (handle hGrip)
var
	string strTemp
let strTemp = GetWindowText (hGrip, true)
Pause ()
While ((strTemp > "") &&
(! IsKeyWaiting ()) &&
(! DialogActive ()))
	let strTemp = GetWindowText (hGrip, true)
	Delay (10)
EndWhile
CloseList ()
EndFunction

Void Function CloseList ()
var
	int iTop,
	int iLeft,
	handle hWnd
If (! GetWindowText (GlobalFocusWindow, true)) then
	SpeechOff ()
	SaveCursor ()
	JAWSCursor ()
	RouteJAWSToPC ()
	JAWSPageDown ()
	JAWSHome ()
	PriorLine ()
	RestrictCursor (ON)
	JAWSPageUp ()
	JAWSHome ()
	RestrictCursor (OFF)
	Pause ()
	If GetWord () == msg158_L Then ; "close"
		LeftMouseButton ()
	EndIf
	Delay (2)
	let hWnd = FindDescendantWindow (GetAppMainWindow (GetFocus ()), iGlobalPrevControl)
	If (! hWnd) then
		let hWnd = FindDescendantWindow (GetAppMainWindow (GetFocus ()), iD_Messages_List)
	EndIf
	let iLeft = GetWindowLeft (hWnd)
	let iTop = GetWindowTop (hWnd)
	MoveTo (iLeft, iTop)
	LeftMouseButton ()
	PcCursor ()
EndIf
Pause ()
;If (GetWindowSubTypeCode (GetCurrentWindow ()) == WT_LISTVIEW) then
;	Pause ()
;	{control+f4}
;EndIf
let nSuppressEcho = false
SpeechOn ()
EndFunction

Int Function SkipHeaders ()
var
	string strText,
	int iIndex,
	int iType,
	int iCol,
	int iRow
If (nSkipHeaders) then
	Return
EndIf
If ! IsVirtualPcCursor () then
	Return false
EndIf
let iType = 0;
Delay (4) ; to allow Virtual Cursor to catch up
let iIndex = 0;
let iCol = GetCursorCol ()
let iRow = GetCursorRow ()
If (iRow > 5) then
	Return false
EndIf
let strText = GetLine ()
let strText = StringSegment (strText, msgDim_L, 1)
let nSuppressEcho = true;
While ((strText != wn35) && (iIndex < 60))
	NextLine ()
	let strText = GetLine ()
	let strText = StringSegment (strText, msgDim_L, 1)
let iIndex = iIndex + 1
EndWhile
NextLine ()
let iIndex = 0
While (GetLine () > "" && iIndex < 25)
	NextLine ()
	let iIndex = iIndex + 1
EndWhile
NextLine ()
	SayMessage (OT_control_type, msg3_L)
let nSuppressEcho = false
Return true
EndFunction

Int Function DoCustomDialog (string strDLG, handle hReal)
var
	handle hTemp
If (! DialogActive ()) then
	Return false
EndIf
If (strDLG == "") then
	let hTemp = FindDescendantWindow (hReal, iD_Static_About)
	If (! hTemp) then
		Return false
	EndIf
	SayWindow (hTemp, false)
	Return true
ElIf (strDLG == wn10) then
	let hTemp = FindDescendantWindow (hReal, ID_Static)
	SayWindow (hTemp, false)
	Return true
ElIf (strDLG == wn1) then
	let hTemp = FindDescendantWindow (hReal, ID_Static)
	Say (GetWindowText (hTemp, false), ot_NO_DISABLE)
	Return True
ElIf (strDlg == wn31) then
	let hTemp = FindDescendantWindow (hReal, iD_Static2)
	SayWindow (hTemp, Read_Everything)
	Return true
ElIf (strDLG == wn36) then
	let hTemp = FindDescendantWindow (hReal, iD_Static2)
	If (! hTemp) then
		Return
	EndIf
	SayWindow (hTemp, Read_Everything)
	Return true
EndIf
Return false
EndFunction

Int Function AddressBook (string strName, int iD, handle hWnd)
var
	int iBool
If (strName != wn16) then
	let iBool = false
	Return iBool
EndIf
let iBool = true;
If (iD == iD_Email || iD == iD_Email2) then
	SayMessage (OT_CONTROL_NAME, msg1_L); "E-mail address"
	SayWindowTypeAndText (hWnd)
	SayWindow (hWnd, Read_Everything)
	Return iBool
ElIf (iD == iD_Notes || iD == iD_Notes2) then
	SayMessage (OT_CONTROL_NAME, msg2_L); "Notes"
EndIf
SayWindowTypeAndText (hWnd)
Return iBool
EndFunction

Int Function IsMessageWindow (int iD)
var
	int iBool
If (DialogActive ()) then
	let iBool = false
	Return iBool
EndIf
let iBool = IsVirtualPcCursor ()
	If (iBool) then
	Return iBool
EndIf
If (iD == ID_TO ||
iD == ID_From ||
iD == ID_Subject ||
iD == ID_Cc ||
iD == iD_Bcc ||
iD == iD_Attach) then
	let iBool = true
Else
	let iBool = false
EndIf
Return iBool
EndFunction

Void Function AddressBookMessage ()
If EudoraFirstTime == 1 then
	SayMessage (OT_app_start, msg135_L, msg135_s); "After selecting a nickname or address book from the tree, press the f6 key to edit its properties"
EndIf
EndFunction

Void Function FilterMessage ()
SayMessage (OT_HELP, msg155_L, msg155_s); "Once you select a filter in the list or press the new button, press the f6 key to modify its properties"
EndFunction

Void Function SayNonHighlightedText (handle HWND, string Buffer)
var
	int iWinType,
	int iControl,
	string TheClass
let iWinType = GetWindowSubTypeCode (hWnd)
If (iWinType == WT_LISTVIEW) then
	let iControl = GetControlID (hWnd)
	If ((iControl == 0) ||
	(iControl == iD_ListView)) then
		If (DownloadSpeak == 1) then
			Say (buffer, OT_BUFFER)
			Return
		EndIf
	EndIf
EndIf
If (nSuppressEcho) then
	Return
EndIf
; To automatically close and speak the download information
;Added by Ken Gould
If StringContains (buffer, "Sorry, you don't") || StringContains (buffer, "You have new") Then
If (! DialogActive ()) then
	{SpaceBar}
	SpeechOff ()
	Pause ()
	JAWSCursor ()
	RouteJAWSToPC ()
	JAWSPageDown ()
	JAWSHome ()
	PriorLine ()
	RestrictCursor (ON)
	JAWSPageUp ()
	JAWSHome ()
	RestrictCursor (OFF)
	Pause ()
	If GetWord () == "close" Then
		Pause ()
		LeftMouseButton ()
		EndIf
		SpeechOn ()
		PCCursor ()
		Return
	EndIf
EndIf
let TheClass = GetWindowClass(hwnd)
let iControl = GetControlID (hWnd)
; for the SpellCheck dialog
If (hWnd == GetFocus ()) then
	If (iControl == ID_Spell_Correct) then
		PerformScript ReadMistakeAndSuggestion ()
		Return
	EndIf
EndIf
;The following section prevents excess verbiage during download
If (StringContains (Buffer, msg107_L) || ; "Verif"
StringContains (Buffer, msg108_L) || ; "Shut"
StringContains (Buffer, msg109_L) ||; "Log"
StringContains (Buffer, msg110_L) || ; "UIDL"
StringContains (Buffer, msg111_L) || ; "Authen"
StringContains (Buffer, msg112_L) || ; "Quit"
StringContains (Buffer, msg113_L) || ; "connect"
StringContains (Buffer, msg114_L) || ; "User"
StringContains (Buffer, msg115_L) || ; "new mail"
StringContains (Buffer, msg116_L) || ; "Starting"
StringContains (Buffer, msg117_L) || ; "RETR"
StringContains (Buffer, msg118_L) ||; "DELE"
StringContains (Buffer, msg125_L) || ;"Waiting"
StringContains (Buffer, msg127_L) || ;"Dialing"
StringContains (Buffer, msg119_L)) Then; "LIST"
	return
EndIf; End of excess verbiage during download test
If (GetScreenEcho () > 0) then
	If (hWnd == GetFocus ()) then
		If (GetWindowSubTypeCode (hWnd) == WT_COMBOBOX) then
			Say (buffer, OT_BUFFER)
			Return
		EndIf
	EndIf
EndIf
if ((GetScreenEcho() > 1) ||
;wn36="#32771"
; wcDialog2 = ; "#32771"
(TheClass == wcDialog2 ) || 
(TheClass == wcToolTips) || ; "ToolTips_Class32"
(GetControlID (hwnd) == 8081 &&DownLoadSpeak != 0) || ;test added by Ken Gould to make 4.1 download speak
((TheClass == wcStatic) && (GetWindowClass (GetFocus ())) == "Button") && (DownloadSpeak != 0)) then; "Static"
if GetVerbosity ()>=1 then
if StringContains (buffer, msgDownload_L) then 
	If (EudoraVersion >= 4) then
		let buffer=StringLeft (buffer, 2)
	ElIf (EudoraVersion << 4) then
		let buffer=StringRight (buffer, 2)
	EndIf
endif 
endif
	Say (buffer, OT_BUFFER)
EndIf
EndFunction

Void Function SayHighlightedText (handle hwnd, string buffer)
var
	int iWinType,
	int iControl,
	handle hFocus
let iWinType = GetWindowSubTypeCode (hWnd)
If (iWinType == WT_LISTVIEW) then
	let iControl = GetControlID (hWnd)
	If ((iControl == 0) ||
	(iControl == iD_ListView)) then
		If (DownloadSpeak == 1) then
			If (GetVerbosity () > beginner) then
				If ((StringContains (buffer, msgDownload_L)) ||
				(StringContains (buffer, msgSend_L))) then
					let buffer = StringLeft (buffer, 2)
				EndIf
			EndIf
			Say (buffer, OT_BUFFER)
		EndIf
		Return
	EndIf
EndIf
If (nSuppressEcho == true) then
	Return
EndIf
;Added by Ken Gould
; To prevent extra chatter in the Task List while downloading mail
If (GlobalMenuMode == 0) then
	If (! InHJDialog ()) then
		If (GetWindowSubTypeCode (hWnd) != WT_EXTENDEDSELECT_LISTBOX) then
			If (StringContains (Buffer, msg107_L) || ; "Verif"
			StringContains (Buffer, msg108_L) || ; "Shut"
			StringContains (Buffer, msg109_L) ||; "Log"
			StringContains (Buffer, msg110_L) || ; "UIDL"
			StringContains (Buffer, msg111_L) || ; "Authen"
			StringContains (Buffer, msg112_L) || ; "Quit"
			StringContains (Buffer, msg113_L) || ; "connect"
			StringContains (Buffer, msg114_L) || ; "User"
			StringContains (Buffer, msg115_L) || ; "new mail"
			StringContains (Buffer, msg116_L) || ; "Starting"
			StringContains (Buffer, msg117_L) || ; "RETR"
			StringContains (Buffer, msg118_L) ||; "DELE"
			StringContains (Buffer, msg125_L) || ;"Waiting"
			StringContains (Buffer, msg127_L) || ;"Dialing"
			StringContains (Buffer, msg119_L)) Then; "LIST"
				Return
			EndIf
		EndIf
	EndIf
EndIf
let hFocus = GetFocus ()
; wn20 = "Check Spelling"
If (GetControlID (GetFocus ()) == ID_Spell_Correct) then
	If hwnd == hFocus then
		PerformScript ReadMistakeAndSuggestion ()
		Return
	EndIf
EndIf
If (GlobalMenuMode == 0) then
	If (DialogActive ()) then
		If (hWnd != hFocus) then
			Return
		EndIf
	EndIf
EndIf
If (GlobalMenuMode == 0) then
	If (hWnd != hFocus) then
		Return
	EndIf
EndIf
SayHighlightedText (hWnd, buffer)
EndFunction

Void Function FocusChangedEvent (handle FocusWindow, handle PrevWindow)
var
	int iControl,
	int iPrevControl,
	handle RealWindow,
	string RealWindowName,
	handle AppWindow
if IsJavaWindow(FocusWindow) then
	switchToScriptFile ("java", "eudora")
endif
let RealWindow = GetRealWindow (FocusWindow)
let RealWindowName = GetWindowName (RealWindow)
let AppWindow = GetAppMainWindow (FocusWindow)
if (GlobalPrevApp != AppWindow && AppWindow != FocusWindow) then
	; we've switched to a different app main window,
	; and it does not have the focus, so announce it
endif
If ((GlobalPrevRealName != RealWindowName) ; name has changed
|| (GlobalPrevReal != RealWindow)) then ; or handle has changed, then
	If ((RealWindow != AppWindow) && (RealWindow != FocusWindow)) && (! nSuppressEcho) then
		let iControl = GetControlID (FocusWindow)
		let iPrevControl = GetControlID (PrevWindow)
		If (! IsMessageWindow (iControl) &&
		! IsMessageWindow (iPrevControl)) then
			If (RealWindowName == wn20) then ; "Check Spelling"
				SayMessage (OT_DIALOG_NAME, msg136_L, msg136_s)
			Else
				SayWindowTypeAndText (RealWindow)
			EndIf
		EndIf
	DoCustomDialog (RealWindowName, RealWindow)
	endif
EndIf
let GlobalFocusWindow = FocusWindow
If (! DialogActive ()) then
	let iControl = GetControlID (GlobalFocusWindow)
	If (iControl != iD_ListView) then
		let iGlobalPrevControl = iControl
	EndIf
EndIf
if (GlobalPrevFocus != focusWindow) then
	SayFocusedWindow (RealWindowName) ; will use global variable GlobalFocusWindow
else
	SayFocusedObject ()
EndIf
;above perform will return here to finish this routine
;now set all the global variables for next time.
let GlobalPrevReal = RealWindow
let GlobalPrevRealName = RealWindowName
let GlobalPrevApp = AppWindow
let GlobalPrevFocus = FocusWindow
EndFunction

Void Function SayFocusedWindow (string RealName)
var
	int iDlgBool,; for reduced checks for DialogActive ()
	int iControl
let iDlgBool = DialogActive ()
If nSuppressEcho then
	If (! iDlgBool) then
		Return
	EndIf
EndIf
If (IsVirtualPcCursor ()) then
	If (SkipHeaders ()) then
		Return
	Else
			SayMessage (OT_control_type, msg3_L)
	EndIf
	Return
EndIf
let iControl = GetControlID (GlobalFocusWindow)
; wn16 = "Address Book"
If (RealName == wn16) then
	If (AddressBookFirstTime == 0) then
		let AddressBookFirstTime = 1
		AddressBookMessage ()
	EndIf
EndIf
; wn11 = "Filters"
If (RealName == wn11) then
	If (FilterFirstTime == 0) then
		let FilterFirstTime = 1
		FilterMessage ()
	EndIf
EndIf
If (iControl == iD_Edit || iControl == iD_View) then
	If iControl == iD_Edit Then ;Added by nicfer
		SayMessage (OT_control_type, msg3_L); "Edit"
	EndIf
	Return
EndIf
If (AddressBook (RealName, iControl, GlobalFocusWindow) == true) then
	Return
EndIf
If (iDlgBool) then
	If (iControl == ID_Spell_Correct) then
		; wn20 = "Check Spelling"
		If (RealName == wn20) then
			PerformScript ReadMistakeAndSuggestion ()
			Return
		EndIf
	EndIf
EndIf
If (iControl == iD_ListView) then
	let nSuppressEcho = true
	If (GlobalPrevRealName == wn21) ||
	(GlobalPrevRealName == wn33) then
		If (! iDlgBool) then
			CloseList ()
			Return
		EndIf
	Else
		Pause (); give it a process length in time to prepare for strcomp
		CloseListMain (GlobalFocusWindow)
		Return
	EndIf
	Return
EndIf
; If first test fails
If ((!iControl) &&
(GetWindowSubTypeCode (GlobalFocusWindow) == WT_LISTVIEW)) then
	If (GlobalPrevRealName == wn21) ||
	(GlobalPrevRealName == wn33) then
	CloseList ()
;	Else
;		Pause (); Give it one process length to prepare for strcmp
;		CloseListMain (GlobalFocusWindow)
	EndIf
	Return
EndIf
SayWindowTypeAndText (GlobalFocusWindow)
EndFunction

Script ScriptFileName ()
ScriptAndAppNames ("Eudora")
EndScript

Script SayWindowPromptAndText ()
var
	int iControl,
	handle hCurrent,
	string sRealName
let hCurrent = GetCurrentWindow ()
let iControl = GetControlID (hCurrent)
If (iControl == iD_Edit || iControl == iD_View) then
	SayMessage (OT_CONTROL_type, msg3_L); "Edit"
	Return
EndIf
let sRealName = GetWindowName (GetRealWindow (hCurrent))
If not AddressBook (sRealName, iControl, hCurrent) then
	SayWindowTypeAndText (hCurrent)
EndIf
EndScript

Script ScreenSensitiveHelp ()
var
	handle hWnd,
	int iWinType,
	int iControl
If (IsSameScript ()) then
	AppFileTopic (topic_Eudora)
	Return
EndIf
let hWnd = GetCurrentWindow ()
let iControl = GetControlID (hWnd)
If (iControl == iD_Edit) then
	ScreenSensitiveHelpForKnownClasses (WT_EDIT)
	Return
EndIf
If (iControl == iD_View) then
	ScreenSensitiveHelpForKnownClasses (WT_READONLYEDIT)
	Return
EndIf
If (IsVirtualPcCursor ()) then
	let iWinType = GetWindowSubTypeCode (GetFocus ())
	If (iWinType) then
		ScreenSenSitiveHelpVirtualCursor (iWinType)
		Return
	EndIf
	SayMessage (OT_HELP, msg159_L, msg159_s); "This is the Microsoft Viewer"
	SayMessage (OT_HELP, msg160_L, msg160_s); "You can read it as you would a web page in Internet Explorer 5 or a document in a word processor"
	Return
EndIf
PerformScript ScreenSensitiveHelp()
EndScript

Script HotKeyHelp ()
	 SayMessage(OT_HELP, msgExtendedHelp_L, msgExtendedHelp_S )
If (DialogActive ()) then
	; wn20 = "Check Spelling"
	If (GetWindowName (GetRealWindow (GetFocus ())) == wn20) then
		SayMessage (OT_HELP, (Msg153_L + GetScriptKeyName ("ReadMistakeAndSuggestion")), (msg153_s + GetScriptKeyName("ReadMistakeAndSuggestion"))); "To read and spell the unknown word and default suggestion press"
		SayMessage (OT_HELP, (msg154_L + GetScriptKeyName ("ReadWordInContext")), (msg154_s + GetScriptKeyName("ReadWordInContext"))); "To read the unknown  word in context press"
	EndIf
	HotKeyHelpDefaultLoop ()
	Return
EndIf
PerformScript HotKeyHelp ()
EndScript

Script WindowKeysHelp ()
var
	handle hWnd,
	int iControl
let hWnd = GetCurrentWindow ()
let iControl = GetControlID (hWnd)
If (iControl == iD_View) then
	SayMessage (OT_HELP, msg137_L, msg137_s); "The following shortcut keys can be useful when reading a message"
	SayMessage (OT_HELP, msg138_L, msg138_s); "To reply press control + r"
	SayMessage (OT_HELP, msg142_L, msg142_s); "To reply with options press control+shift+r"
	SayMessage (OT_HELP, msg139_L, msg139_s); "To place the sender in your address book press control + k"
	SayMessage (OT_HELP, msg143_L, msg143_s); "To open the address book press control + l"
	SayMessage (OT_HELP, msg140_L, msg140_s); "To compose a new message press control+n"
	SayMessage (OT_HELP, msg141_L, msg141_s); "To compose a new message with options press control+shift+n"
	Return
EndIf
If (iControl == iD_Edit) then
	If (GetWindowClass (GetPriorWindow (hWnd)) == wcDialog) then
		SayMessage (OT_HELP, msg144_L, msg144_s); "The following shortcut keys can be useful when in the preview pane"
		SayMessage (OT_HELP, msg145_L, msg145_s); "To return to the list of messages press tab"
		SayMessage (OT_HELP, msg146_L, msg146_s); "To turn off the preview pane, from the tools menu select options and then Viewing Mail"
	SayMessage (OT_HELP, msg147_L, msg147_s); "Uncheck the Use Preview Pane checkbox and press OK"
		SayMessage (OT_HELP, msg148_L, msg148_s); "You may need to restart Eudora for the changes to take effect"
		Return
	EndIf
	SayMessage (OT_HELP, msg149_L, msg149_s); "The following shortcut keys can be useful when editing a message"
	SayMessage (OT_HELP, msg150_L, msg150_s); "To spell check the current message press control + 6"
	SayMessage (OT_HELP, msg151_L, msg151_s); "To Send the current message press control + e"
	SayMessage (OT_HELP, msg152_L, msg152_s); "To send cued messages press control + t"
	Return
EndIf
PerformScript WindowKeysHelp ()
EndScript

Script  JawsBackspace()
var
	int TheTypeCode,
	int PrevRow,
	int NewRow,
	int PrevCol,
	int NewCol,
	handle PrevWin,
	handle NewWin
let TheTypeCode = GetObjectSubtypeCode()
If ((TheTypeCode == WT_TREEVIEW) || (TheTypeCode == WT_LISTVIEW)) then
 {backspace}
	return
EndIf
SaveCursor ()
RouteInvisibleToPc ()
InvisibleCursor ()
Let PrevRow = GetCursorRow ()
let PrevCol = GetCursorCol ()
let prevWin = GetCurrentWindow ()
PriorCharacter ()
Let NewRow = GetCursorRow ()
Let NewCol = GetCursorCol ()
let NewRow = NewRow+5 ;add a little extra space to make sure the  row has actually changed
let newWin = GetCurrentWindow ()
If (NewRow < PrevRow) then
	SayMessage (ot_no_disable, msgBlank_L)
	RestoreCursor ()
	{Backspace}
	return
EndIf
If NewCol <= (PrevCol - 8) then
	If (GetWindowClass (GetFocus ()) == WCEdit) then
		; Must use Focus Point here, as we are concerned with the main client area
		If GetCharacter () != " " then
			SayMessage (OT_NO_DISABLE, msgSpace_L)
			{Backspace}
			Return
		EndIf
	EndIf
EndIf
If (NewWin != PrevWin) then
	SayMessage (ot_no_disable, msgBlank_L)
	RestoreCursor ()
	{Backspace}
	return
EndIf
SayCharacter ()
RestoreCursor ()
{backspace}
EndScript

Script JawsDelete ()
; so the delete dialog will speak properly.
var
	handle winHandle,
	string theClass,
	int cId
let winHandle = GetCurrentWindow ()
let theClass = GetWindowClass (winHandle)
let cId = GetControlID (winHandle)
If (cId == ID_Messages_List) &&
(theClass == wcListBox) &&
(IsPCCursor ()) then
	let nSuppressEcho = true
	{delete}
	let nSuppressEcho = false
	Return
EndIf
PerformScript JawsDelete()
EndScript

Script  NextDocumentWindow() 
var
Int AddressControlID
{control+tab}
delay (1)
Let AddressControlID = GetCurrentControlID ()
if (IsMultiPageDialog ()) then
	Say (GetDialogPageName (), OT_DIALOG_NAME )
	return
endif
If (AddressControlID == 1453 ||AddressControlID == 432) Then
SayMessage (OT_CONTROL_NAME, msg1_L) ; "E-mail Address"
EndIf
If (AddressControlId == 1454 || AddressControlID == 433) Then
SayMessage (OT_CONTROL_NAME, msg2_L) ; "Notes"
SayWindow (GetCurrentWindow (), read_everything)
EndIf
EndScript

Script PreviousDocumentWindow() 
Var
Int AddressControlID
{control+shift+tab}
Delay (1)
Let AddressControlID = GetCurrentControlID ()
if (IsMultiPageDialog ()) then
	Say (GetDialogPageName (), OT_DIALOG_NAME )
	return
endif
If (AddressControlID == 1453 || AddressControlID == 432) Then
SayMessage (OT_CONTROL_NAME, msg1_L) ; "E-mail address"
EndIf
If (AddressControlId == 1454 || AddressControlID == 433) Then
SayMessage (OT_CONTROL_NAME, msg2_L) ; "Notes"
SayWindow (GetCurrentWindow (), read_everything)
EndIf
EndScript

Script CloseTaskList ()
SayMessage (OT_STATUS, msg128_L, msg128_s) ; "Close Task Status Window"
JAWSCursor ()
RouteJAWSToPC ()
JAWSPageDown ()
JAWSHome ()
PriorLine ()
RestrictCursor (ON)
JAWSPageUp ()
JAWSHome ()
RestrictCursor (OFF)
Pause ()
If GetWord () == msg158_L Then ; "close"
	LeftMouseButton ()
	PCCursor ()
	Delay (2)
	FocusEudora ()
	SayMessage (OT_STATUS, msg129_L)
Else
	PCCursor ()
	SayMessage (OT_error, msg130_L, msg130_s); "Sorry, couldn't find close symbol."
EndIf
EndScript

Script DownloadSpeak ()
If (DownloadSpeak == 0) Then
Let DownloadSpeak = 1
SayMessage (OT_STATUS, msg40_L, msg40_s) ; "Turning on speaking of download message status."
Return
EndIf
If (DownloadSpeak == 1) Then
Let DownloadSpeak = 0
SayMessage (OT_STATUS, msg41_L, msg41_s) ; "Turning off speaking of download message status."
EndIf
EndScript

Script ReadMistakeAndSuggestion ()
var 
	handle hReal, 
	handle hTemp,
	string strText,
	string sRealName
let hReal = GetRealWindow (GetFocus ())
let sRealName = GetWindowName (hReal)
;wn20 = "Check Spelling"
If (sRealName != wn20) then
SayMessage (OT_error, msg16_L) ; "You must be in the spell checker to use this function."
Return
EndIf
let hTemp = FindDescendantWindow (hReal, ID_Spell_Mistake)
If ((hTemp) && (IsWindowVisible (hTemp))) then
	SayWindowTypeAndText (GetPriorWindow (hTemp))
	let strText = GetWindowText (hTemp, false)
	Say (strText, OT_NO_DISABLE); speak the word
	SpellString (strText)
EndIf
let hTemp = FindDescendantWindow (hReal, ID_Spell_List)
If ((hTemp) && (IsWindowVisible (hTemp))) then
	let strText = GetWindowText (hTemp, false)
	If (! StrText) then
		SayMessage (OT_NO_DISABLE, msg19_L); "No suggestions"
		Return
	EndIf
EndIf
let hTemp = FindDescendantWindow (hReal, ID_Spell_Correct)
If ((hTemp) && IsWindowVisible (hTemp)) then
	let strText = GetWindowText (hTemp, false)
	SayWindowTypeAndText (hTemp)
	SpellString (strText)
EndIf
EndScript

Script ReadWordInContext ()
var
	handle hApp,
	handle hTemp,
	int iCompare,
	int iControl
If (! DialogActive ()) then
	SayMessage (OT_error, msg156_L); "Word In Context Not Found"
	Return
EndIf
let hApp = GetAppMainWindow (GetFocus ())
let iCompare = iD_Edit
let hTemp = FindDescendantWindow (hApp, iCompare)
let iControl = GetControlID (hTemp)
If (iControl == iCompare) then
	SaveCursor ()
	JawsCursor ()
	MoveToWindow (hTemp)
	If (FindNextAttribute (ATTRIB_HIGHLIGHT)) then
	SayLine ()	
	Else
		SayMessage (OT_error, msg157_L, msg157_s); "The highlighted word may be covered up"
		SayMessage (OT_error, msg26_L); "If this hot key says the highlighted word is covered up, change the message window back to restored for better results."
	EndIf
	Return
EndIf
EndScript

Script  OpenSignatures()
;Script to open signature choice list
	SayMessage (OT_STATUS, msg100_L) ; "Signatures list"
;msg106_L = "Priority"
If (FindGraphic (GetAppMainWindow (GetCurrentWindow ()), msg106_L, S_Top, S_Unrestricted)) Then
NextWord () NextWord () NextWord ()
Pause ()
LeftMouseButton ()
PcCursor ()
Else
	SayMessage (OT_error, msg101_L, msg101_s) ; "could not be found."
EndIf
EndScript

Script ReplyToAuthor ()
;Script to reply to author of list server message instead of replying to list server.
;Courtesy of David Truong, Dave Maynard, and Patrick Burke
;Revised by David Maynard 1/26/99
; Revised by David Maynard 4/5/2000
var
	int count ; added 4/5/2000 DCM

;Generates a Reply to the original sender (From field). 
SayMessage (OT_STATUS, msg36_L) ; "Reply to author, Please waite"
{space} ;make sure you are in an opened message 
Delay (5) 
{control+home} ; move to the top of the document 
Delay (2) ; Added 11/8/98 DCM
RouteJAWSToPc () 
JAWSCursor () 
; Find and copy the Sender's address to the Clipboard. 
; msg122 = "from:"
;FindString (GetCurrentWindow (), msg122, s_top, s_restricted) 
; The previous line was commented out and the next 4 lines added 4/5/200 by
; DCM
While GetWord () != msg122_L || count ==60 
NextLine ()
let count = count + 1
EndWhile
If GetWord () == msg122_L then 
         SpeechOff () ; added 11/8/98 DCM
         NextWord () 
         ;msg123 = "@"
         While GetCharacter () != msg123_L ; Added 11/8/98 DCM
                 NextCharacter () ; Added 11/8/98 DCM
         EndWhile ; Added 11/8/98 DCM
         While GetCharacter () != " " ; Added 11/8/98 DCM
                 PriorCharacter () ; Added 11/8/98 DCM
         EndWhile ; Added 11/8/98 DCM
         RoutePcToJaws() 
         PcCursor () 
         {SHIFT+END} 
         {CTRL+C} 
         ; Create the Reply message and insert Sender's address. 
         {CTRL+R} 
         Delay (2) ;Added 11/8/98 DCM
         SaveCursor () 
         {alt + o} ; now at the "to" line 
         Delay (2) ; Added 11/8/98 DCM
         {CTRL+A} ;select the contents of the ToBox
         {DELETE} 
         {CTRL+V} ;paste in new address
         Delay (3) 
         RestoreCursor () 
         {TAB} {TAB} {TAB} {TAB} {TAB} ;Now at message box
         Delay (10) 
         {enter} 
         {left arrow} 
         SpeechOn () ; Added 11/8/98 DCM
         SayMessage (OT_JAWS_MESSAGE, msg37_L) ; "Please type your message then press ctrl e to send."
Else 
SayMessage (OT_ERROR, msg38_L) ; "make sure you are replying to a list serve message"
EndIf 
EndScript

Script NewMessageFrom ()
; Added by Dave Baker 
; 1/99
; for reading the From field of messages
SaveCursor ()
If (! FindDescendantWindow (GetRealWindow (GetCurrentWindow ()), ID_From)) then
	SayMessage (OT_error, msg79_L) ; "Not in message edit window"
	Return
EndIf
InvisibleCursor ()
RouteInvisibleToPc ()
MoveToWindow (FindDescendantWindow (GetRealWindow (GetCurrentWindow ()), ID_From))
NextWord () ; to ensure that we are actually in the window
If (GetControlID (GetCurrentWindow ()) != ID_From) then
	SayMessage (OT_error, msg85_L) ; "from"
	SayMessage (ot_error, msg82_L) ; "not found"
	RestoreCursor ()
	Return
EndIf
SayMessage (OT_CONTROL_NAME, msg85_L) ; "from"
SayWindow (GetCurrentWindow (), Read_Everything)
RestoreCursor ()
EndScript

Script NewMessageTo ()
;Script to read names in To field of message
; and edit them if necessary
; revised 1/99 by Dave Baker
If (! FindDescendantWindow (GetRealWindow (GetCurrentWindow ()), ID_From)) then
	SayMessage (OT_error, msg79_L) ; "Not in message edit window"
	Return
EndIf
SaveCursor ()
InvisibleCursor ()
RouteInvisibleToPc ()
MoveToWindow (FindDescendantWindow (GetRealWindow (GetCurrentWindow ()), ID_To))
If (GetControlID (GetCurrentWindow ()) != ID_To) then
	SayMessage (OT_error, msg33_L) ; "To"
	SayMessage (OT_error, msg82_L) ; "not found"
	RestoreCursor ()
	Return
EndIf
If (IsSameScript ()) then
	RoutePCToInvisible ()
	Return
EndIf
SayMessage (OT_CONTROL_NAME, msg33_L) ; "to"
SayWindow (GetCurrentWindow (), Read_Everything)
	SayMessage (OT_smart_help, msg83_L, msgSilent) ; "press twice to edit"
RestoreCursor ()
EndScript

Script NewMessageSubject ()
; Added by Dave Baker
; to allow reading and editing of subject fields during message composition
If (! FindDescendantWindow (GetRealWindow (GetCurrentWindow ()), ID_From)) then
	SayMessage (OT_error, msg79_L) ; "Not in message edit window"
	Return
EndIf

SaveCursor ()
InvisibleCursor ()
RouteInvisibleToPc ()
MoveToWindow (FindDescendantWindow (GetRealWindow (GetCurrentWindow ()), ID_Subject))
If (GetControlID (GetCurrentWindow ()) != ID_Subject) then
	SayMessage (OT_error, msg84_L) ; "subject"
	SayMessage (OT_error, msg82_L) ; "not found"
	RestoreCursor ()
	Return
EndIf
If (IsSameScript ()) then
	RoutePCToInvisible ()
	Return
EndIf
SayMessage (OT_CONTROL_NAME, msg84_L) ; "subject"
SayWindow (GetCurrentWindow (), Read_Everything)
	SayMessage (OT_smart_help, msg83_L, msgSilent) ; "press twice to edit"
RestoreCursor ()
EndScript

Script NewMessageCC ()
;Script to speak name in CC field of message
; and edit it if necessary
; revised 1/99 by Dave Baker
; to allow movement to and editing the field
If (! FindDescendantWindow (GetRealWindow (GetCurrentWindow ()), ID_From)) then
	SayMessage (OT_error, msg79_L) ; "Not in message edit window"
	Return
EndIf
SaveCursor ()
InvisibleCursor ()
RouteInvisibleToPc ()
MoveToWindow (FindDescendantWindow (GetRealWindow (GetCurrentWindow ()), ID_Cc))
If (GetControlID (GetCurrentWindow ()) != ID_Cc) then
	SayMessage (OT_error, msg34_L) ; "cc"
	SayMessage (OT_error, msg82_L) ; "not found"
	RestoreCursor ()
	Return
EndIf
If (IsSameScript ()) then
	RoutePCToInvisible ()
	Return
EndIf
SayMessage (OT_CONTROL_NAME, msg34_L) ; "cc"
SayWindow (GetCurrentWindow (), Read_Everything)
	SayMessage (OT_smart_help, msg83_L, msgSilent) ; "press twice to edit"
RestoreCursor ()
EndScript

Script NewMessageBCC ()
;Script to speak names in BCC field of new message
; and edit them if necessary
; revised 1/99 by Dave Baker
If (! FindDescendantWindow (GetRealWindow (GetCurrentWindow ()), ID_From)) then
	SayMessage (OT_error, msg79_L) ; "Not in message edit window"
	Return
EndIf
SaveCursor ()
InvisibleCursor ()
RouteInvisibleToPc ()
MoveToWindow (FindDescendantWindow (GetRealWindow (GetCurrentWindow ()), ID_BCc))
If (GetControlID (GetCurrentWindow ()) != ID_Bcc) then
	SayMessage (OT_error, msg35_L) ; "Bcc"
	SayMessage (OT_error, msg82_L) ; "not found"
	RestoreCursor ()
	Return
EndIf
If (IsSameScript ()) then
	RoutePCToInvisible ()
	Return
EndIf
SayMessage (OT_CONTROL_NAME, msg35_L) ; "bcc"
SayWindow (GetCurrentWindow (), Read_Everything)
	SayMessage (OT_smart_help, msg83_L, msgSilent) ; "press twice to edit"
RestoreCursor ()
EndScript

Script MoveToMessageBody ()
var
	int counter,
	int iControl,
	handle hTemp,
	handle winhandle,
	string TheClass
let WinHandle = GetCurrentWindow ()
let TheClass = GetWindowClass (WinHandle)
let iControl = GetControlID (WinHandle)
If (iControl == ID_Signatures_List) then
	let hTemp = WinHandle
	let hTemp = GetParent (GetParent (hTemp))
	let hTemp = GetFirstChild (GetPriorWindow (hTemp))
	let hTemp = GetNextWindow (hTemp)
	If (GetWindowClass (hTemp) == WCEdit) then
		JawsCursor ()
		MoveToWindow (hTemp)
		LeftMouseButton ()
		RoutePcToJaws ()
		PcCursor ()
		Return
	EndIf
EndIf
If (! FindDescendantWindow (GetRealWindow (WinHandle), ID_From)) ||
(TheClass == WCDialog) then
	SayMessage (OT_error, msg79_L) ; "Not in message edit window"
	Return
EndIf
If (GetControlID (WinHandle) == ID_Edit) then
	SayMessage (OT_error, msg80_L) ; "already in message body window"
	Return
EndIf
RouteInvisibleToPc ()
InvisibleCursor ()
let WinHandle = GetNextWindow (GetParent (GetCurrentWindow ()))
If (GetControlID (WinHandle) != ID_Edit) then
	SayMessage (OT_error, msg81_L) ; "message body not found"
	PcCursor ()
	Return
EndIf
MoveToWindow (WinHandle)
Delay (2)
RoutePCToInvisible ()
PcCursor ()
SayLine ()
EndScript

Script MessageBodyDelete ()
; by John Carson,
; Modified by DaveB
; for Eudora versions 3 and 4.x. 
var
	handle hWnd,
	handle WinHandle,
	int iId,
	string TheClass
let hWnd = FindDescendantWindow (GetAppMainWindow (winHandle), ID_ListBox)
let WinHandle = GetCurrentWindow ()
let iId = GetControlID (hWnd)
let TheClass = GetWindowClass (hWnd)
{Control + D}
; Verbosity Check 
let nSuppressEcho = false
	SayMessage (OT_STATUS, msg99_L) ; "Delete"
Pause ()
Delay (2)
; if no windows are open
if (! hWnd) &&
(TheClass == WCNoWindows) then
		SayMessage (OT_error, msg96_L) ; "There are no mailboxes open at this time"
		SayMessage (OT_error, msg97_L, msgSilent) ; "The window with focus will not serve you until you open a mailbox"
		SayMessage (OT_error, msg98_L) ; "Press control plus 1 to open the Inbox"
	Return
EndIf
let hWnd = GetFocus ()
; For Messages list box (no matter what mailbox)
If (iId == ID_Messages_List) then
	Return
EndIf
if (iId == ID_View) ||
(IsVirtualPcCursor ()) ||
(iId == ID_Edit) then
	let nSuppressEcho = true
	StopSpeech ()
	SaveCursor ()
	InvisibleCursor ()
	Delay (3)
	FindString (GetRealWindow (GetFocus ()), "From:", S_Top, S_Unrestricted)
	SayLine ()
	NextLine ()
SayLine ()
	RestoreCursor ()
	PCCursor ()
	;SayLine ()
	let nSuppressEcho = false
	Return 
EndIf
EndScript

Script IEFind ()
if IsVirtualPCCursor () then
	SayMessage (ot_error, msg586_L, msg586_s) 
	SayMessage (ot_error, msg587_L, msg587_s) 
	if JAWSFind () &&
	IsVirtualPCCursor () then
		SayLine ()
	EndIf
	Return
else 
	TypeCurrentScriptKey ()
EndIf
EndScript

Script OpenFindResultsList ()
;script to activate results list in Find Messages Dialog, added by kag
; wn29 = "Messages",
var
	handle hWnd,
	int nEcho
SayCurrentScriptKeyLabel ()
let hWnd = FindDescendantWindow (GetRealWindow (GetFocus ()), iD_FindResultsList)
If (hWnd && IsWindowVisible (hWnd)) then
	SayMessage (OT_CONTROL_NAME, msg132_L); "Results list"
	SaveCursor ()
	JawsCursor ()
	MoveToWindow (hWnd)
	LeftMouseButton ()
	RestoreCursor ()
Else
	let nEcho = GetJcfOption (OPT_TYPING_ECHO)
	TypeCurrentScriptKey ()
EndIf
EndScript

Script SayTitle ()
If EudoraVersion < 5 then
	SayFrame ("MessageTitle4")
Else
	SayFrame ("MessageTitle5")
EndIf
EndScript
